/*      (c) 1993-2001 Marc H.E. Vos +
 *      Netherlands                 +
 *                                  +
 *      email: marc@vos.net         */

pgm parm(&mbr &pgmsrc &dspfsrc &prtfsrc &action &cvtmsg &genlib)

   dcl &mbr     *char 10
   dcl &pgmsrc  *char 20
   dcl &dspfsrc *char 20
   dcl &prtfsrc *char 20
   dcl &action  *char  2
   dcl &cvtmsg  *char  2
   dcl &genlib  *char 10

   dcl &pgmfil  *char 10
   dcl &pgmlib  *char 10
   dcl &dspffil *char 10
   dcl &dspflib *char 10
   dcl &prtffil *char 10
   dcl &prtflib *char 10

   dcl &msgdta  *char 50
   dcl &anerror *dec (1 0)
   dcl &tomsgq  *dec (1 0)
   dcl &libadd  *dec (1 0)
   dcl &null    *char 10 ('          ')
   dcl &codembr *char 10
   dcl &card    *char  1
   dcl &cvttype *char  7
   dcl &srcmbr  *char 10
   dcl &genmsgq *char 10 ('E$LNG_GMSG')
   dcl &pgmgen  *char 10 ('E$RPGSRC')
   dcl &dspfgen *char 10 ('E$DSPFSRC')
   dcl &prtfgen *char 10 ('E$PRTFSRC')
   dcl &fldnum  *char  4
   dcl &fldnsv  *char  4

   dclf *libl/qrpgsrc

/* -------------------- Procedure Section -------------------- */

   addlible e$lng *last
   monmsg cpf0000

   rmvlible qtemp
   monmsg cpf0000
   addlible qtemp *first
   monmsg cpf0000

   chgvar &pgmfil  (%sst(&pgmsrc  01 10))
   chgvar &pgmlib  (%sst(&pgmsrc  11 10))

   if (&dspfsrc *eq '*P') do
      chgvar &dspffil (&pgmfil)
      chgvar &dspflib (&pgmlib)
   enddo
   else do
      chgvar &dspffil (%sst(&dspfsrc 01 10))
      chgvar &dspflib (%sst(&dspfsrc 11 10))
   enddo

   if (&prtfsrc *eq '*D') do
      chgvar &prtffil (&dspffil)
      chgvar &prtflib (&dspflib)
   enddo
   else do
      chgvar &prtffil (%sst(&prtfsrc 01 10))
      chgvar &prtflib (%sst(&prtfsrc 11 10))
   enddo

   if (&genlib *eq '*P') do
      chgvar &genlib (&pgmlib)
   enddo

/* --- Create message queue to hold messages */

   chkobj qtemp/&genmsgq objtype(*msgq)
   monmsg cpf0000 exec(do)
      crtmsgq msgq(qtemp/&genmsgq) text('Generation messages')
   enddo
   clrmsgq qtemp/&genmsgq
   monmsg cpf0000

/* --- Check if source objects exist */

   chgvar &tomsgq (0)
   chgvar &anerror (0)

   chkobj &pgmlib/&pgmfil objtype(*file) mbr(&mbr)
   monmsg cpf0000 exec(do)
      chgvar &msgdta (&pgmlib *cat &pgmfil *cat &mbr *cat 'RPG')
      sndpgmmsg msgid(LNG0101) msgf(e$lngmsf) msgdta(&msgdta) +
                topgmq(*prv) tomsgq(&genmsgq)
      chgvar &tomsgq (1)
      chgvar &anerror (1)
   enddo

   chkobj &dspflib/&dspffil objtype(*file)
   monmsg cpf0000 exec(do)
      chgvar &msgdta (&dspflib *cat &dspffil *cat &null *cat 'DSPF')
      sndpgmmsg msgid(LNG0101) msgf(e$lngmsf) msgdta(&msgdta) +
                topgmq(*prv) tomsgq(&genmsgq)
      chgvar &tomsgq (1)
      chgvar &anerror (1)
   enddo

   chkobj &prtflib/&prtffil objtype(*file)
   monmsg cpf0000 exec(do)
      chgvar &msgdta (&prtflib *cat &prtffil *cat &null *cat 'PRTF')
      sndpgmmsg msgid(LNG0101) msgf(e$lngmsf) msgdta(&msgdta) +
                topgmq(*prv) tomsgq(&genmsgq)
      chgvar &tomsgq (1)
      chgvar &anerror (1)
   enddo

   if (&anerror *ne 0) goto Finish

/* --- Check if generation objects exist */

   if (&action *ne '*E') chgvar &genlib ('QTEMP     ') /* Check mode */

   /* Verify Generation Library */
   chkobj *libl/&genlib objtype(*lib)
   monmsg cpf0000 exec(do)
      chgvar &genlib ('E$LNG_GEN ')
      chkobj *libl/&genlib objtype(*lib)
         monmsg cpf0000 exec(do)
            crtlib &genlib type(*test) text('Temporary +
                          Generation Library (rename it)')
            monmsg cpf0000 exec(do)
               sndpgmmsg msgid(LNG0102) msgf(e$lngmsf) topgmq(*prv) +
                         tomsgq(&genmsgq)
               chgvar &tomsgq (1)
               goto Finish
            enddo
         enddo
   enddo

   /* Verify generation RPG Source File */
   chkobj &genlib/&pgmgen objtype(*file)
   monmsg cpf0000 exec(do)
      crtsrcpf file(&genlib/&pgmgen) text('E$LNG Converted RPG source')
      monmsg cpf0000 exec(do)
         chgvar &msgdta (&genlib *cat &pgmgen)
         sndpgmmsg msgid(LNG0103) msgf(e$lngmsf) msgdta(&msgdta) +
                   topgmq(*prv) tomsgq(&genmsgq)
         chgvar &tomsgq (1)
         goto Finish
      enddo
   enddo

   /* Verify generation DSPF Source File */
   chkobj &genlib/&dspfgen objtype(*file)
   monmsg cpf0000 exec(do)
      crtsrcpf file(&genlib/&dspfgen) text('E$LNG Converted DSPF source')
      monmsg cpf0000 exec(do)
         chgvar &msgdta (&genlib *cat &dspfgen)
         sndpgmmsg msgid(LNG0103) msgf(e$lngmsf) msgdta(&msgdta) +
                   topgmq(*prv) tomsgq(&genmsgq)
         chgvar &tomsgq (1)
         goto Finish
      enddo
   enddo

   /* Verify generation PRTF Source File */
   chkobj &genlib/&prtfgen objtype(*file)
   monmsg cpf0000 exec(do)
      crtsrcpf file(&genlib/&prtfgen) text('E$LNG Converted PRTF source')
      monmsg cpf0000 exec(do)
         chgvar &msgdta (&genlib *cat &prtfgen)
         sndpgmmsg msgid(LNG0103) msgf(e$lngmsf) msgdta(&msgdta) +
                   topgmq(*prv) tomsgq(&genmsgq)
         chgvar &tomsgq (1)
         goto Finish
      enddo
   enddo

   /* Verify Literal Reference File */
   chkobj &pgmlib/E$LNGREF objtype(*file)
   monmsg cpf0000 exec(do)
      chgvar &msgdta (&pgmlib *cat 'E$LNGREF  ')
      sndpgmmsg msgid(LNG0106) msgf(e$lngmsf) msgdta(&msgdta) +
                topgmq(*prv) tomsgq(&genmsgq)
      chgvar &tomsgq (1)
      goto Finish
   enddo

   /* Verify Extraction Definitions File */
   chkobj &pgmlib/E$LNGDT1 objtype(*file)
   monmsg cpf0000 exec(do)
      chgvar &msgdta (&pgmlib *cat 'E$LNGDT1  ')
      sndpgmmsg msgid(LNG0106) msgf(e$lngmsf) msgdta(&msgdta) +
                topgmq(*prv) tomsgq(&genmsgq)
      chgvar &tomsgq (1)
      goto Finish
   enddo

   /* Verify Language Definitions File */
   chkobj *libl/E$LNGDT2 objtype(*file)
   monmsg cpf0000 exec(do)
      chgvar &msgdta ('*LIBL     E$LNGDT2  ')
      sndpgmmsg msgid(LNG0106) msgf(e$lngmsf) msgdta(&msgdta) +
                topgmq(*prv) tomsgq(&genmsgq)
      chgvar &tomsgq (1)
      goto Finish
   enddo

/* --- Create workspace in QTEMP */
/* Workspace for converting DSPF/PRTF */
   clrpfm qtemp/e$work
   monmsg cpf0000 exec(do)
      crtpf qtemp/e$work rcdlen(132) size(*nomax) maxmbrs(*nomax)
      monmsg cpf0000 exec(do)
         chgvar &msgdta ('E$WORK    ')
         sndpgmmsg msgid(LNG0105) msgf(e$lngmsf) msgdta(&msgdta) +
                   topgmq(*prv) tomsgq(&genmsgq)
         chgvar &tomsgq (1)
         goto Finish
      enddo
   enddo

/* Workspace for generated RPG sourcecode */
   clrpfm qtemp/e$rpggen
   monmsg cpf0000 exec(do)
      crtpf qtemp/e$rpgg rcdlen(132) size(*nomax) maxmbrs(*nomax)
      monmsg cpf0000 exec(do)
         chgvar &msgdta ('E$RPGGEN  ')
         sndpgmmsg msgid(LNG0105) msgf(e$lngmsf) msgdta(&msgdta) +
                   topgmq(*prv) tomsgq(&genmsgq)
         chgvar &tomsgq (1)
         goto Finish
      enddo
      rnmobj qtemp/e$rpgg objtype(*file) newobj(e$rpggen)
   enddo

/* Workspace for converted RPG source member */
   clrpfm qtemp/e$rpgcvt
   monmsg cpf0000 exec(do)
      crtdupobj obj(e$rpggen) fromlib(qtemp) objtype(*file) +
                tolib(qtemp) newobj(e$rpgcvt) data(*no)
      monmsg cpf0000 exec(do)
         chgvar &msgdta ('E$RPGCVT  ')
         sndpgmmsg msgid(LNG0105) msgf(e$lngmsf) msgdta(&msgdta) +
                   topgmq(*prv) tomsgq(&genmsgq)
         chgvar &tomsgq (1)
         goto Finish
      enddo
   enddo

/* --- Add PGMLIB and GENLIB to librarylist */
   chgvar &libadd (1)
   addlible &pgmlib *first
   monmsg cpf0000 exec(chgvar &libadd (0))
   addlible &genlib *first
   monmsg cpf0000

/* --- Read file, search for WORKSTN or PRINTER */

   chgvar &fldnum ('0000')
   ovrdbf qrpgsrc &pgmlib/&pgmfil &mbr

Loop1:
   rcvf
   monmsg cpf0000 exec(goto Endloop1)

   chgvar &card    (%sst(&srcdta  6 1))
   chgvar &srcmbr  (%sst(&srcdta  7 8))
   chgvar &cvttype (%sst(&srcdta 40 7))

   if (&card *eq 'E' *or &card *eq 'I' *or &card *eq 'C') do
      goto Endloop1
   enddo

   if (&card *eq 'F') do
      if (&cvttype *eq 'WORKSTN') do
         chkobj obj(&dspflib/&dspffil) objtype(*file) mbr(&srcmbr)
         monmsg cpf0000 exec(do)
            chgvar &msgdta (&dspflib *cat &dspffil *cat &srcmbr *cat +
                            &genlib *cat &dspfgen)
            sndpgmmsg msgid(LNG0104) msgf(e$lngmsf) msgdta(&msgdta) +
                      topgmq(*prv) tomsgq(&genmsgq)
            chgvar &tomsgq (1)
            goto Finish
         enddo

         chgvar &fldnsv &fldnum
         cpysrcf &dspflib/&dspffil &genlib/&dspfgen frommbr(&srcmbr) +
              mbropt(*replace)
         cpyf &dspflib/&dspffil qtemp/e$work frommbr(&srcmbr) +
              mbropt(*replace) fmtopt(*cvtsrc) compress(*yes)

         call E$LNG1D parm(&srcmbr &genlib &dspfgen &action +
                            &cvtmsg &fldnum)

         if (&fldnum *ne 'ZZZZ') do
            cpyf qtemp/e$work &genlib/&dspfgen frommbr(*first) +
                 tombr(&srcmbr) mbropt(*replace) fmtopt(*cvtsrc) +
                 compress(*yes)
         enddo
         else do
            chgvar &fldnum &fldnsv
            rmvm &genlib/&dspfgen mbr(&srcmbr)
         enddo
      enddo
      else if (&cvttype *eq 'PRINTER') do
         chkobj obj(&prtflib/&prtffil) objtype(*file) mbr(&srcmbr)
         monmsg cpf0000 exec(do)
            chgvar &msgdta (&prtflib *cat &prtffil *cat &srcmbr *cat +
                            &genlib *cat &prtfgen)
            sndpgmmsg msgid(LNG0104) msgf(e$lngmsf) msgdta(&msgdta) +
                      topgmq(*prv) tomsgq(&genmsgq)
            chgvar &tomsgq (1)
            goto Finish
         enddo

         chgvar &fldnsv &fldnum
         cpysrcf &prtflib/&prtffil &genlib/&prtfgen frommbr(&srcmbr) +
              mbropt(*replace)
         cpyf &prtflib/&prtffil qtemp/e$work frommbr(&srcmbr) +
              mbropt(*replace) fmtopt(*cvtsrc) compress(*yes)

         call E$LNG1P parm(&srcmbr &genlib &prtfgen &action +
                            &cvtmsg &fldnum)

         if (&fldnum *ne 'ZZZZ') do
            cpyf qtemp/e$work &genlib/&prtfgen frommbr(*first) +
                 tombr(&srcmbr) mbropt(*replace) fmtopt(*cvtsrc) +
                 compress(*yes)
         enddo
         else do
            chgvar &fldnum &fldnsv
            rmvm &genlib/&prtfgen mbr(&srcmbr)
         enddo
      enddo
   enddo

   goto Loop1

Endloop1:
   dltovr qrpgsrc

   if (&action *ne '*C') do
      cpyf &pgmlib/&pgmfil qtemp/e$work frommbr(&mbr) +
           mbropt(*replace) fmtopt(*cvtsrc) compress(*yes)

      chgvar &codembr (&mbr)
      call E$LNG1I parm(&codembr &genlib &pgmgen)

      if (&codembr *ne '*NONE') do
         /* Master RPG source */
         cpysrcf &pgmlib/&pgmfil &genlib/&pgmgen frommbr(&mbr) +
              mbropt(*replace)
         monmsg cpf0000 exec(do)
            chgvar &msgdta (&pgmlib *cat &pgmfil *cat &mbr *cat +
                            &genlib *cat &pgmgen)
            sndpgmmsg msgid(LNG0104) msgf(e$lngmsf) msgdta(&msgdta) +
                      topgmq(*prv) tomsgq(&genmsgq)
            chgvar &tomsgq (1)
            goto Finish
         enddo

         cpyf qtemp/e$rpgcvt &genlib/&pgmgen frommbr(*first) +
              tombr(&mbr) mbropt(*replace) fmtopt(*cvtsrc) +
              compress(*yes)

         /* Header */
         cpysrcf e$lng/src &genlib/&pgmgen frommbr(e$zzz) +
              tombr(&codembr) mbropt(*replace)

         cpyf qtemp/e$rpggen &genlib/&pgmgen frommbr(*first) +
              tombr(&codembr) mbropt(*add) fmtopt(*cvtsrc) +
              compress(*yes)
      enddo
   enddo

Finish:
   dltovr qrpgsrc
   monmsg cpf0000

   if (&tomsgq *eq 1) wrkmsg qtemp/&genmsgq
   if (&libadd *eq 1) do
      rmvlible &pgmlib
      monmsg cpf0000
      rmvlible &genlib
      monmsg cpf0000
   enddo

Quit:
endpgm
